/*
 * Main.cpp
 *
 * Created: 7/5/2013 5:48:14 PM
 *  Author: Omar
 */



#ifndef SKETCH_H_
#include "Sketch.h"
#endif

#include <Led.h>

/* Running counter */
static unsigned long counter = 0;

/* Micro-controller connected LED */
Led led;

/***************************************************
Return LED as ILed to isolate caller from what
type of ILed is used
****************************************************/
ILed* getLed()
{
	return &led;
}

 void setup()
 {
	 /* Initialize LED */
	 led.Init(LED);
	 
	 /* Initialize serial interface */
	 Serial.begin(SERIAL_SPEED);
	 
	 /* Show build information via serial interface */
#if defined(ENABLE_TEXT_MESSAGE)
	ShowBuildInfo();
#endif	

 }

 void loop()
 {
	 getLed()->On();
	 delay(DELAY_LENGTH);
	 getLed()->Off();
	 delay(DELAY_LENGTH);
	 Serial.print(MESSAGE);
	 Serial.println( ++counter );
 }
 